<?php

namespace FiloBlu\Refilo\Remote;

use Magento\Framework\DataObject;
use Magento\Store\Model\ScopeInterface;
use Magento\Store\Api\Data\StoreInterface;

/**
 * Class CatalogProdutIndexer
 * @package FiloBlu\Refilo\Remote
 */
class AttributeIndexer extends AbstractStoreBasedIndexer
{
    const REFILO_CONFIG_PRICE_FILTERABLE_RANGE_STEP = "refilo_catalog/categories/price_filterable_range_step";

    public function getEntitiesToRemove(array $ids = [])
    {
    }

    public function beforeExecute(array $ids = [])
    {
    }

    public function postExecute(array $ids = [])
    {
    }
    /**
     * @return string
     */
    protected function getClass(): string
    {
        return __CLASS__;
    }

    /**
     * @param $entities
     * @param $collection
     * @return mixed|void
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     */
    public function write($entities, $collection)
    {
        $this->getConnector()->create($entities,$collection);
    }

    /**
     * @param StoreInterface $store
     * @return DataObject
     */
    public function prepareConnectorMetadata(StoreInterface $store): DataObject
    {
        $metadata = parent::prepareConnectorMetadata($store);
        $metadata->setData('name', 'attributes');
        $refiloPriceRange = (int)$this->scopeConfig->getValue(self::REFILO_CONFIG_PRICE_FILTERABLE_RANGE_STEP, ScopeInterface::SCOPE_STORE, $store->getCode());
        $metadata->setData('filterable_range_step', ($refiloPriceRange<10)?10:$refiloPriceRange);
        return $metadata;
    }
}
